---
title: Object.prototype.__lookupSetter__()
slug: Web/JavaScript/Reference/Global_Objects/Object/__lookupSetter__
tags:
  - Deprecated
  - JavaScript
  - Method
  - Object
  - Prototype
---
<div>{{JSRef}} {{deprecated_header}}</div>

<p>The <strong><code>__lookupSetter__</code></strong> method returns the function bound as a setter to the specified property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>obj</var>.__lookupSetter__(<var>sprop</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>sprop</var></code></dt>
 <dd>A string containing the name of the property whose setter should be returned.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The function bound as a setter to the specified property.</p>

<h2 id="Description">Description</h2>

<p>If a setter has been defined for an object's property, it was not possible to reference the setter function through that property, because that property refers to the return value of that function. <code>__lookupSetter__</code> can be used to obtain a reference to the setter function.</p>

<p>It is now possible to do this in a standardized way using {{jsxref("Object.getOwnPropertyDescriptor()")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Standard-compliant_and_non-standard_ways_to_get_a_property_setter">Standard-compliant and non-standard ways to get a property setter</h3>

<pre class="brush: js notranslate">var obj = {
  set foo(value) {
    this.bar = value;
  }
};

// Non-standard and deprecated way
obj.__lookupSetter__('foo')
// (function(value) { this.bar = value; })

// Standard-compliant way
Object.getOwnPropertyDescriptor(obj, 'foo').set;
// (function(value) { this.bar = value; })
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.prototype.__lookupSetter__', 'Object.prototype.__lookupSetter__()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.lookupSetter")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.prototype.__lookupGetter__()")}}</li>
 <li>{{jsxref("Functions/set", "set")}} operator</li>
 <li>{{jsxref("Object.getOwnPropertyDescriptor()")}} and {{jsxref("Object.getPrototypeOf()")}}</li>
 <li>{{jsxref("Object.prototype.__defineGetter__()")}}</li>
 <li>{{jsxref("Object.prototype.__defineSetter__()")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Working_with_Objects#Defining_getters_and_setters">JS Guide: Defining Getters and Setters</a></li>
</ul>
